/************************************************************************************/
/*  Program name CAPFNDEXT_CONC_PROG.sql                                            */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDEXT_CONC_PROG';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFND_CONC_PROG.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO			VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT	FCP.*
	FROM
		FND_CONCURRENT_PROGRAMS		FCP,
		FND_CONCURRENT_PROGRAMS_TL	FCPT
	WHERE	SUBSTR(FCPT.User_Concurrent_Program_Name,1,4) = p_NGO
	AND		FCP.Application_ID			=	FCPT.Application_ID
	AND		FCP.Concurrent_Program_ID	=	FCPT.Concurrent_Program_ID
	AND		FCPT.Language				=	'US'
	ORDER BY
		FCP.Application_ID,
		FCP.Concurrent_Program_Name;

BEGIN
	lv_NGO			:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Application_ID||CHR(9)||
				C1.Concurrent_Program_ID||CHR(9)||
				C1.Concurrent_Program_Name||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
				C1.Creation_Date||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Executable_Application_ID||CHR(9)||
				C1.Executable_ID||CHR(9)||				--Should be no Backup/Restore
				C1.Execution_Method_Code||CHR(9)||
				C1.Argument_Method_Code||CHR(9)||
				C1.Queue_Control_Flag||CHR(9)||
				C1.Queue_Method_Code||CHR(9)||
				C1.Request_Set_Flag||CHR(9)||
				C1.Enabled_Flag||CHR(9)||
				C1.Print_Flag||CHR(9)||
				C1.Run_Alone_Flag||CHR(9)||
				C1.SRS_Flag||CHR(9)||
				C1.Class_Application_ID||CHR(9)||
				C1.Concurrent_Class_ID||CHR(9)||
				C1.Execution_Options||CHR(9)||
				C1.Save_Output_Flag||CHR(9)||
				C1.Required_Style||CHR(9)||
				C1.Output_Print_Style||CHR(9)||
				C1.Printer_Name||CHR(9)||
				C1.Minimum_Width||CHR(9)||
				C1.Minimum_Length||CHR(9)||
				C1.Request_Priority||CHR(9)||
				C1.Attribute_Category||CHR(9)||
				C1.Attribute1||CHR(9)||
				C1.Attribute2||CHR(9)||
				C1.Attribute3||CHR(9)||
				C1.Attribute4||CHR(9)||
				C1.Attribute5||CHR(9)||
				C1.Attribute6||CHR(9)||
				C1.Attribute7||CHR(9)||
				C1.Attribute8||CHR(9)||
				C1.Attribute9||CHR(9)||
				C1.Attribute10||CHR(9)||
				C1.Attribute11||CHR(9)||
				C1.Attribute12||CHR(9)||
				C1.Attribute13||CHR(9)||
				C1.Attribute14||CHR(9)||
				C1.Attribute15||CHR(9)||
				C1.Iprog_ID||CHR(9)||
				C1.Output_File_Type||CHR(9)||
				C1.Enable_Trace||CHR(9)||
				C1.Restart||CHR(9)||
				C1.NLS_Compliant||CHR(9)||
				C1.Icon_Name||CHR(9)||
				C1.CD_Parameter||CHR(9)||
				C1.Increment_Proc||CHR(9)||
				C1.MLS_Executable_App_ID||CHR(9)||
				C1.MLS_Executable_ID||CHR(9)||			--Should be no Backup/Restore
				C1.Enable_Time_Statistics||CHR(9)||
				C1.Security_Group_ID||CHR(9)||
				C1.Stat_Collect||CHR(9)||
				C1.Resource_Consumer_Group||CHR(9)||
				C1.Rollback_Segment||CHR(9)||
				C1.Optimizer_Mode||CHR(9)||
				C1.Instance_ID||CHR(9)||
				C1.Refresh_Portlet||CHR(9)||
				C1.Program_Type||CHR(9)||
				C1.Activity_Summarizer||CHR(9)||
				C1.Request_Sch_Interval||CHR(9)||
				C1.Allow_Multiple_Pending_Request||CHR(9)||
				C1.Delete_Log_File||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
		IF	lv_Scc_Count	=	0	THEN
			lv_Err_Msg	:=	lv_NGO||': No Concurrent Program for this NGO';
		END IF;
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/